<?php
include "daemon/master.php" ;
include "daemon/drivers.php" ;
include "daemon/functions.php" ;

$ch  = getData( $_GET, "ch", DATA_NUM, 1, 2 ) ;
$idx  = getData( $_GET, "idx", DATA_NUM, 6, 6 ) ;
$name = getData( $_GET, "name", DATA_AL | DATA_NUM, 3, 3 ) ;
$time = time() ;
if( $name !== NULL && $idx !== NULL && $ch !== NULL ) {
  // load
  $fp = fopen( SYNC_DATA_SERVER, "c+" ) ;
  flock( $fp, LOCK_EX ) ;
  $buf = fread( $fp, 4096 ) ;
  $data = unserialize( $buf ) ;
  if( $data === FALSE ) {
    $data = array() ;
  }
  $ch_data = getArray( $data, $ch, array() ) ;

  // time limit
  $ch_time = getArray( $ch_data, "time" ) ;
  if( $ch_time + SYNC_TIME_LIMIT < $time ) {
    $ch_data = array() ;
  }

  // update
  $ch_data["time"] = $time ;
  $ch_data[$idx] = $name ;
  $data[$ch] = $ch_data ;

  // write
  $wdata = serialize( $data ) ;
  ftruncate( $fp, 0 ) ;
  fflush( $fp ) ;
  fseek( $fp, 0 ) ;
  fwrite( $fp, $wdata ) ;
  flock( $fp, LOCK_UN ) ;
  fclose( $fp ) ;
}
$forward = sprintf( "location: %s?ch=%d", DLIST_LOCATION, $ch ) ;
header( $forward ) ;
exit() ;
?>
